locals {
  wildcard_tags = [
    "Application",
    "Service",
  ]

  enforced_for = [
    "aoss:collection",
    "amplifyuibuilder:app/environment/components",
    "amplifyuibuilder:app/environment/themes",
    "apigateway:apikeys",
    "apigateway:domainnames",
    "apigateway:restapis",
    "apigateway:restapis/stages",
    "appmesh:*",
    "appconfig:application",
    "appconfig:application/configurationprofile",
    "appconfig:application/environment",
    "appconfig:application/environment/deployment",
    "appconfig:deploymentstrategy",
    "athena:*",
    "backup:backup-plan",
    "backup:backup-vault",
    "backup-gateway:gateway",
    "backup-gateway:hypervisor",
    "backup-gateway:vm",
    "batch:job",
    "batch:job-definition",
    "batch:job-queue",
    "acm:*",
    "acm-pca:certificate-authority",
    "cloud9:environment",
    "cloudfront:*",
    "cloudtrail:*",
    "cloudwatch:*",
    "events:*",
    "internetmonitor:monitor",
    "logs:log-group",
    "codebuild:*",
    "codecatalyst:connections",
    "codecommit:*",
    "codeguru-reviewer:association",
    "codeguru-security:scans",
    "codepipeline:*",
    "codestar-connections:connection",
    "codestar-connections:host",
    "cognito-identity:*",
    "cognito-idp:*",
    "comprehend:*",
    "config:*",
    "directconnect:*",
    "dms:*",
    "dynamodb:*",
    "ec2:capacity-reservation",
    "ec2:carrier-gateway",
    "ec2:client-vpn-endpoint",
    "ec2:customer-gateway",
    "ec2:dedicated-host",
    "ec2:dhcp-options",
    "ec2:elastic-ip",
    "ec2:fleet",
    "ec2:fpga-image",
    "ec2:host-reservation",
    "ec2:image",
    "ec2:instance",
    "ec2:internet-gateway",
    "ec2:ipam",
    "ec2:ipam-pool",
    "ec2:ipam-scope",
    "ec2:ipv4pool-ec2",
    "ec2:key-pair",
    "ec2:launch-template",
    "ec2:natgateway",
    "ec2:network-acl",
    "ec2:network-insights-access-scope",
    "ec2:network-insights-access-scope-analysis",
    "ec2:network-insights-analysis",
    "ec2:network-insights-path",
    "ec2:network-interface",
    "ec2:placement-group",
    "ec2:prefix-list",
    "ec2:replace-root-volume-task",
    "ec2:reserved-instances",
    "ec2:route-table",
    "ec2:security-group",
    "ec2:snapshot",
    "ec2:spot-instances-request",
    "ec2:subnet",
    "ec2:traffic-mirror-filter",
    "ec2:traffic-mirror-session",
    "ec2:traffic-mirror-target",
    "ec2:transit-gateway",
    "ec2:transit-gateway-attachment",
    "ec2:transit-gateway-policy-table",
    "ec2:transit-gateway-route-table",
    "ec2:volume",
    "ec2:vpc",
    "ec2:vpc-endpoint",
    "ec2:vpc-endpoint-service",
    "ec2:vpc-peering-connection",
    "ec2:vpn-connection",
    "ec2:vpn-gateway",
    "elasticfilesystem:*",
    "eks:cluster",
    "elasticbeanstalk:application",
    "elasticbeanstalk:applicationversion",
    "elasticbeanstalk:configurationtemplate",
    "elasticbeanstalk:platform",
    "ecr:repository",
    "ecs:cluster",
    "ecs:service",
    "ecs:task-set",
    "elasticache:cluster",
    "es:domain",
    "elasticloadbalancing:*",
    "elasticmapreduce:cluster",
    "elasticmapreduce:editor",
    "emr-serverless:applications",
    "entityresolution:matchingworkflow",
    "entityresolution:schemamapping",
    "pipes:pipe",
    "scheduler:schedule-group",
    "firehose:*",
    "iotfleethub:application",
    "fsx:*",
    "globalaccelerator:accelerator",
    "healthlake:datastore",
    "iam:instance-profile",
    "iam:mfa",
    "iam:oidc-provider",
    "iam:policy",
    "iam:saml-provider",
    "iam:server-certificate",
    "inspector2:filter",
    "kinesisanalytics:*",
    "kms:*",
    "lambda:*",
    "mediastore:container",
    "mq:broker",
    "mq:configuration",
    "network-firewall:firewall",
    "network-firewall:firewall-policy",
    "network-firewall:stateful-rulegroup",
    "network-firewall:stateless-rulegroup",
    "omics:annotationStore",
    "omics:annotationStore/version",
    "omics:referenceStore",
    "omics:referenceStore/reference",
    "omics:run",
    "omics:runGroup",
    "omics:sequenceStore",
    "omics:sequenceStore/readSet",
    "omics:variantStore",
    "omics:workflow",
    "organizations:account",
    "organizations:ou",
    "organizations:policy",
    "organizations:root",
    "rds:cluster-endpoint",
    "rds:cluster-pg",
    "rds:db-proxy",
    "rds:db-proxy-endpoint",
    "rds:es",
    "rds:og",
    "rds:pg",
    "rds:ri",
    "rds:secgrp",
    "rds:subgrp",
    "rds:target-group",
    "redshift:*",
    "redshift-serverless:namespace",
    "redshift-serverless:workgroup",
    "ram:*",
    "resource-groups:*",
    "route53:hostedzone",
    "route53resolver:*",
    "s3:bucket",
    "s3:storage-lens",
    "sagemaker:action",
    "sagemaker:app-image-config",
    "sagemaker:artifact",
    "sagemaker:context",
    "sagemaker:experiment",
    "sagemaker:flow-definition",
    "sagemaker:human-task-ui",
    "sagemaker:model-package",
    "sagemaker:model-package-group",
    "sagemaker:pipeline",
    "sagemaker:processing-job",
    "sagemaker:project",
    "sagemaker:training-job",
    "secretsmanager:*",
    "securitylake:data-lake",
    "securitylake:subscriber",
    "sns:topic",
    "sqs:queue",
    "states:*",
    "storagegateway:*",
    "ssm:association",
    "ssm:automation-execution",
    "ssm:document",
    "ssm:maintenancewindow",
    "ssm:managed-instance",
    "ssm:opsitem",
    "ssm:patchbaseline",
    "ssm-contacts:contact",
    "textract:adapters",
    "textract:adapters/versions",
    "transfer:server",
    "transfer:user",
    "transfer:workflow",
  ]

  tag_value_policies = { for tag, values in local.source : tag => jsonencode({
    tags = {
      "${tag}" = {
        tag_key = {
          "@@assign" = "${tag}"
        }
        tag_value = {
          "@@assign" = values
        }
        enforced_for = {
          "@@assign" = local.enforced_for
        }
      }
    }
  }) }

  tag_wildcard_policies = { for tag in local.wildcard_tags : tag => jsonencode({
    tags = {
      "${tag}" = {
        tag_key = {
          "@@assign" = "${tag}"
        }
        tag_value = {
          "@@assign" = ["*"]
        }
        enforced_for = {
          "@@assign" = local.enforced_for
        }
      }
    }
  }) }

  tag_policies = merge(local.tag_value_policies, local.tag_wildcard_policies)
}

# Ref: https://docs.aws.amazon.com/organizations/latest/userguide/orgs_manage_policies_example-tag-policies.html
output "tag_policies" {
  value = local.tag_policies
}

